Subject: Re: [JGIT] maven build fails on OS X

From: "Shawn O. Pearce" <[email-masked]>
Date: Fri, 6 Feb 2009 07:31:55 -0800

Nigel Magnay <[email-masked]> wrote:
> I don't know if this is known about - I get failures running the m2
> build for jgit:

Yup.
 
> Failed tests:
>   testParse_implicit_mixed_encoded(org.spearce.jgit.revwalk.RevCommitParseTest)
>   testParse_explicit_bad_encoded(org.spearce.jgit.revwalk.RevCommitParseTest)
>   testParse_implicit_mixed_encoded(org.spearce.jgit.revwalk.RevTagParseTest)
>   testParse_explicit_bad_encoded(org.spearce.jgit.revwalk.RevTagParseTest)
>   testDequote_OctalAll(org.spearce.jgit.util.QuotedStringGitPathStyleTest)
>   testDequote_Latin1(org.spearce.jgit.util.QuotedStringGitPathStyleTest)
>   testDequote_RawLatin1(org.spearce.jgit.util.QuotedStringGitPathStyleTest)
>   testGetText_DiffCc(org.spearce.jgit.patch.GetTextTest)
> 
> Curiously, the tests work in eclipse and from ./make_jgit.sh - I
> suspect some environment setting with the mac's charset.

make_jgit.sh doesn't run tests.  But Eclipse does, and as you state,
I have also seen these pass in Eclipse but fail from m2.

What's even more curious is look at the surefire report files for
these tests.  The actual result looks correct, the expected result
looks wrong.  I think m2 miscompiled the Java sources for the tests
somehow and produced incorrect literal strings which are used for
the expected values in the tests.

I don't see these failures on Linux, from either Eclipse or Maven.

> I can try and fix it if it's new, but I wanted to check first..

I've looked at it and gave up.  I don't know what Maven is doing here
on the Mac.  Maybe fresh eyes will have a better chance at fixing it.

My experience with Maven is it works about 5% of the time, and the
other 95% of the time you have to work around it by skipping tests,
or by writing massive blocks of XML in your pom.xml file, or by
redesigning your entire project directory structure and revision
control system to use SVN instead of Git.

-- 
Shawn.